diff -Nru astroid-1.6.5/astroid/brain/brain_namedtuple_enum.py astroid-2.0/astroid/brain/brain_namedtuple_enum.py
--- astroid-1.6.5/astroid/brain/brain_namedtuple_enum.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_namedtuple_enum.py	2018-07-15 09:19:28.000000000 +0200
@@ -1,5 +1,16 @@
+# -*- coding: utf-8 -*-
 # Copyright (c) 2012-2015 LOGILAB S.A. (Paris, FRANCE) <contact@logilab.fr>
-# Copyright (c) 2014-2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2013-2014 Google, Inc.
+# Copyright (c) 2014-2018 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2014 Eevee (Alex Munroe) <amunroe@yelp.com>
+# Copyright (c) 2015-2016 Ceridwen <ceridwenv@gmail.com>
+# Copyright (c) 2015 Dmitry Pribysh <dmand@yandex.ru>
+# Copyright (c) 2015 David Shea <dshea@redhat.com>
+# Copyright (c) 2015 Philip Lorenz <philip@bithub.de>
+# Copyright (c) 2016 Jakub Wilk <jwilk@jwilk.net>
+# Copyright (c) 2016 Mateusz Bysiek <mb@mbdev.pl>
+# Copyright (c) 2017 Hugo <hugovk@users.noreply.github.com>
+# Copyright (c) 2017 Łukasz Rogalski <rogalski.91@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
@@ -7,7 +18,6 @@
 """Astroid hooks for the Python standard library."""
 
 import functools
-import sys
 import keyword
 from textwrap import dedent
 
@@ -21,6 +31,13 @@
 from astroid import util
 
 
+TYPING_NAMEDTUPLE_BASENAMES = {
+    'NamedTuple',
+    'typing.NamedTuple'
+}
+ENUM_BASE_NAMES = {'Enum', 'IntEnum', 'enum.Enum', 'enum.IntEnum'}
+
+
 def _infer_first(node, context):
     if node is util.Uninferable:
         raise UseInferenceDefault
@@ -81,7 +98,6 @@
             else:
                 # Enums supports either iterator of (name, value) pairs
                 # or mappings.
-                # TODO: support only list, tuples and mappings.
                 if hasattr(names, 'items') and isinstance(names.items, list):
                     attributes = [_infer_first(const[0], context).value
                                   for const in names.items
@@ -122,6 +138,15 @@
     return class_node, name, attributes
 
 
+def _has_namedtuple_base(node):
+    """Predicate for class inference tip
+
+    :type node: ClassDef
+    :rtype: bool
+    """
+    return set(node.basenames) & TYPING_NAMEDTUPLE_BASENAMES
+
+
 def _looks_like(node, name):
     func = node.func
     if isinstance(func, nodes.Attribute):
@@ -130,14 +155,20 @@
         return func.name == name
     return False
 
+
 _looks_like_namedtuple = functools.partial(_looks_like, name='namedtuple')
 _looks_like_enum = functools.partial(_looks_like, name='Enum')
+_looks_like_typing_namedtuple = functools.partial(_looks_like, name='NamedTuple')
 
 
 def infer_named_tuple(node, context=None):
     """Specific inference function for namedtuple Call node"""
-    class_node, name, attributes = infer_func_form(node, nodes.Tuple._proxied,
-                                                   context=context)
+    tuple_base_name = nodes.Name(name='tuple', parent=node.root())
+    class_node, name, attributes = infer_func_form(
+        node,
+        tuple_base_name,
+        context=context,
+    )
     call_site = arguments.CallSite.from_call(node)
     func = next(extract_node('import collections; collections.namedtuple').infer())
     try:
@@ -232,11 +263,10 @@
 
 def infer_enum_class(node):
     """ Specific inference for enums. """
-    names = set(('Enum', 'IntEnum', 'enum.Enum', 'enum.IntEnum'))
     for basename in node.basenames:
         # TODO: doesn't handle subclasses yet. This implementation
         # is a hack to support enums.
-        if basename not in names:
+        if basename not in ENUM_BASE_NAMES:
             continue
         if node.root().name == 'enum':
             # Skip if the class is directly from enum module.
@@ -246,6 +276,7 @@
                    for value in values):
                 continue
 
+            targets = []
             stmt = values[0].statement()
             if isinstance(stmt, nodes.Assign):
                 if isinstance(stmt.targets[0], nodes.Tuple):
@@ -255,19 +286,29 @@
             elif isinstance(stmt, nodes.AnnAssign):
                 targets = [stmt.target]
 
+            inferred_return_value = None
+            if isinstance(stmt.value, nodes.Const):
+                if isinstance(stmt.value.value, str):
+                    inferred_return_value = '"{}"'.format(stmt.value.value)
+                else:
+                    inferred_return_value = stmt.value.value
+
             new_targets = []
             for target in targets:
                 # Replace all the assignments with our mocked class.
                 classdef = dedent('''
-                class %(name)s(%(types)s):
+                class {name}({types}):
                     @property
                     def value(self):
-                        # Not the best return.
-                        return None
+                        return {return_value}
                     @property
                     def name(self):
-                        return %(name)r
-                ''' % {'name': target.name, 'types': ', '.join(node.basenames)})
+                        return {name}
+                '''.format(
+                    name=target.name,
+                    types=', '.join(node.basenames),
+                    return_value=inferred_return_value,
+                ))
                 fake = AstroidBuilder(MANAGER).string_build(classdef)[target.name]
                 fake.parent = target.parent
                 for method in node.mymethods():
@@ -278,8 +319,79 @@
     return node
 
 
-MANAGER.register_transform(nodes.Call, inference_tip(infer_named_tuple),
-                           _looks_like_namedtuple)
-MANAGER.register_transform(nodes.Call, inference_tip(infer_enum),
-                           _looks_like_enum)
-MANAGER.register_transform(nodes.ClassDef, infer_enum_class)
+def infer_typing_namedtuple_class(class_node, context=None):
+    """Infer a subclass of typing.NamedTuple"""
+    # Check if it has the corresponding bases
+    annassigns_fields = [
+        annassign.target.name for annassign in class_node.body
+        if isinstance(annassign, nodes.AnnAssign)
+    ]
+    code = dedent('''
+    from collections import namedtuple
+    namedtuple({typename!r}, {fields!r})
+    ''').format(
+        typename=class_node.name,
+        fields=",".join(annassigns_fields)
+    )
+    node = extract_node(code)
+    generated_class_node = next(infer_named_tuple(node, context))
+    for method in class_node.mymethods():
+        generated_class_node.locals[method.name] = [method]
+    return iter((generated_class_node, ))
+
+
+def infer_typing_namedtuple(node, context=None):
+    """Infer a typing.NamedTuple(...) call."""
+    # This is essentially a namedtuple with different arguments
+    # so we extract the args and infer a named tuple.
+    try:
+        func = next(node.func.infer())
+    except InferenceError:
+        raise UseInferenceDefault
+
+    if func.qname() != 'typing.NamedTuple':
+        raise UseInferenceDefault
+
+    if len(node.args) != 2:
+        raise UseInferenceDefault
+
+    if not isinstance(node.args[1], (nodes.List, nodes.Tuple)):
+        raise UseInferenceDefault
+
+    names = []
+    for elt in node.args[1].elts:
+        if not isinstance(elt, (nodes.List, nodes.Tuple)):
+            raise UseInferenceDefault
+        if len(elt.elts) != 2:
+            raise UseInferenceDefault
+        names.append(elt.elts[0].as_string())
+
+    typename = node.args[0].as_string()
+    node = extract_node('namedtuple(%(typename)s, (%(fields)s,)) ' %
+        {'typename': typename, 'fields': ",".join(names)})
+    return infer_named_tuple(node, context)
+
+
+MANAGER.register_transform(
+    nodes.Call, inference_tip(infer_named_tuple),
+    _looks_like_namedtuple,
+)
+MANAGER.register_transform(
+    nodes.Call, inference_tip(infer_enum),
+    _looks_like_enum,
+)
+MANAGER.register_transform(
+    nodes.ClassDef, infer_enum_class,
+    predicate=lambda cls: any(basename for basename in cls.basenames
+                              if basename in ENUM_BASE_NAMES)
+)
+MANAGER.register_transform(
+    nodes.ClassDef,
+    inference_tip(infer_typing_namedtuple_class),
+    _has_namedtuple_base,
+)
+MANAGER.register_transform(
+    nodes.Call,
+    inference_tip(infer_typing_namedtuple),
+    _looks_like_typing_namedtuple,
+)
diff -Nru astroid-1.6.5/astroid/brain/brain_nose.py astroid-2.0/astroid/brain/brain_nose.py
--- astroid-1.6.5/astroid/brain/brain_nose.py	2018-05-13 12:38:38.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_nose.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,4 +1,5 @@
 # Copyright (c) 2015-2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2016 Ceridwen <ceridwenv@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
diff -Nru astroid-1.6.5/astroid/brain/brain_numpy.py astroid-2.0/astroid/brain/brain_numpy.py
--- astroid-1.6.5/astroid/brain/brain_numpy.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_numpy.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,4 +1,6 @@
-# Copyright (c) 2015-2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2015-2016, 2018 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2016 Ceridwen <ceridwenv@gmail.com>
+# Copyright (c) 2017-2018 hippo91 <guillaume.peillex@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
@@ -150,30 +152,307 @@
 def numpy_core_numerictypes_transform():
     return astroid.parse('''
     # different types defined in numerictypes.py
-    uint16 = type('uint16') 
-    uint32 = type('uint32')
-    uint64 = type('uint64')
-    int128 = type('int128')
-    uint128 = type('uint128')
-    float16 = type('float16')
-    float32 = type('float32')
-    float64 = type('float64')
-    float80 = type('float80')
-    float96 = type('float96')
-    float128 = type('float128')
-    float256 = type('float256')
-    complex32 = type('complex32')
-    complex64 = type('complex64')
-    complex128 = type('complex128')
-    complex160 = type('complex160')
-    complex192 = type('complex192')
-    complex256 = type('complex256')
-    complex512 = type('complex512')
-    timedelta64 = type('timedelta64')
-    datetime64 = type('datetime64')
-    unicode_ = type('unicode_')
-    string_ = type('string_')
-    object_ = type('object_')
+    class generic(object):
+        def __init__(self, value):
+            self.T = None
+            self.base = None
+            self.data = None
+            self.dtype = None
+            self.flags = None
+            self.flat = None
+            self.imag = None
+            self.itemsize = None
+            self.nbytes = None
+            self.ndim = None
+            self.real = None
+            self.size = None
+            self.strides = None
+
+        def all(self): pass
+        def any(self): pass
+        def argmax(self): pass
+        def argmin(self): pass
+        def argsort(self): pass
+        def astype(self): pass
+        def base(self): pass
+        def byteswap(self): pass
+        def choose(self): pass
+        def clip(self): pass
+        def compress(self): pass
+        def conj(self): pass
+        def conjugate(self): pass
+        def copy(self): pass
+        def cumprod(self): pass
+        def cumsum(self): pass
+        def data(self): pass
+        def diagonal(self): pass
+        def dtype(self): pass
+        def dump(self): pass
+        def dumps(self): pass
+        def fill(self): pass
+        def flags(self): pass
+        def flat(self): pass
+        def flatten(self): pass
+        def getfield(self): pass
+        def imag(self): pass
+        def item(self): pass
+        def itemset(self): pass
+        def itemsize(self): pass
+        def max(self): pass
+        def mean(self): pass
+        def min(self): pass
+        def nbytes(self): pass
+        def ndim(self): pass
+        def newbyteorder(self): pass
+        def nonzero(self): pass
+        def prod(self): pass
+        def ptp(self): pass
+        def put(self): pass
+        def ravel(self): pass
+        def real(self): pass
+        def repeat(self): pass
+        def reshape(self): pass
+        def resize(self): pass
+        def round(self): pass
+        def searchsorted(self): pass
+        def setfield(self): pass
+        def setflags(self): pass
+        def shape(self): pass
+        def size(self): pass
+        def sort(self): pass
+        def squeeze(self): pass
+        def std(self): pass
+        def strides(self): pass
+        def sum(self): pass
+        def swapaxes(self): pass
+        def take(self): pass
+        def tobytes(self): pass
+        def tofile(self): pass
+        def tolist(self): pass
+        def tostring(self): pass
+        def trace(self): pass
+        def transpose(self): pass
+        def var(self): pass
+        def view(self): pass
+
+
+    class dtype(object):
+        def __init__(self, obj, align=False, copy=False):
+            self.alignment = None
+            self.base = None
+            self.byteorder = None
+            self.char = None
+            self.descr = None
+            self.fields = None
+            self.flags = None
+            self.hasobject = None
+            self.isalignedstruct = None
+            self.isbuiltin = None
+            self.isnative = None
+            self.itemsize = None
+            self.kind = None
+            self.metadata = None
+            self.name = None
+            self.names = None
+            self.num = None
+            self.shape = None
+            self.str = None
+            self.subdtype = None
+            self.type = None
+
+        def newbyteorder(self, new_order='S'): pass
+
+
+    class ndarray(object):
+        def __init__(self, shape, dtype=float, buffer=None, offset=0,
+                     strides=None, order=None):
+            self.T = None
+            self.base = None
+            self.ctypes = None
+            self.data = None
+            self.dtype = None
+            self.flags = None
+            self.flat = None
+            self.imag = None
+            self.itemsize = None
+            self.nbytes = None
+            self.ndim = None
+            self.real = None
+            self.shape = None
+            self.size = None
+            self.strides = None
+
+        def all(self): pass
+        def any(self): pass
+        def argmax(self): pass
+        def argmin(self): pass
+        def argpartition(self): pass
+        def argsort(self): pass
+        def astype(self): pass
+        def byteswap(self): pass
+        def choose(self): pass
+        def clip(self): pass
+        def compress(self): pass
+        def conj(self): pass
+        def conjugate(self): pass
+        def copy(self): pass
+        def cumprod(self): pass
+        def cumsum(self): pass
+        def diagonal(self): pass
+        def dot(self): pass
+        def dump(self): pass
+        def dumps(self): pass
+        def fill(self): pass
+        def flatten(self): pass
+        def getfield(self): pass
+        def item(self): pass
+        def itemset(self): pass
+        def max(self): pass
+        def mean(self): pass
+        def min(self): pass
+        def newbyteorder(self): pass
+        def nonzero(self): pass
+        def partition(self): pass
+        def prod(self): pass
+        def ptp(self): pass
+        def put(self): pass
+        def ravel(self): pass
+        def repeat(self): pass
+        def reshape(self): pass
+        def resize(self): pass
+        def round(self): pass
+        def searchsorted(self): pass
+        def setfield(self): pass
+        def setflags(self): pass
+        def sort(self): pass
+        def squeeze(self): pass
+        def std(self): pass
+        def sum(self): pass
+        def swapaxes(self): pass
+        def take(self): pass
+        def tobytes(self): pass
+        def tofile(self): pass
+        def tolist(self): pass
+        def tostring(self): pass
+        def trace(self): pass
+        def transpose(self): pass
+        def var(self): pass
+        def view(self): pass
+
+
+    class busdaycalendar(object):
+        def __init__(self, weekmask='1111100', holidays=None):
+            self.holidays = None
+            self.weekmask = None
+
+    class flexible(generic): pass
+    class bool_(generic): pass
+    class number(generic): pass
+    class datetime64(generic): pass
+   
+
+    class void(flexible):
+        def __init__(self, *args, **kwargs):
+            self.base = None
+            self.dtype = None
+            self.flags = None
+        def getfield(self): pass
+        def setfield(self): pass
+
+
+    class character(flexible): pass
+
+
+    class integer(number):
+        def __init__(self, value):
+           self.denominator = None
+           self.numerator = None
+
+
+    class inexact(number): pass
+
+
+    class str_(str, character):
+        def maketrans(self, x, y=None, z=None): pass
+
+    
+    class bytes_(bytes, character):
+        def fromhex(self, string): pass
+        def maketrans(self, frm, to): pass
+
+
+    class signedinteger(integer): pass
+
+
+    class unsignedinteger(integer): pass
+
+
+    class complexfloating(inexact): pass
+
+
+    class floating(inexact): pass
+
+
+    class float64(floating, float):
+        def fromhex(self, string): pass 
+
+        
+    class uint64(unsignedinteger): pass
+    class complex64(complexfloating): pass
+    class int16(signedinteger): pass
+    class float96(floating): pass
+    class int8(signedinteger): pass
+    class uint32(unsignedinteger): pass
+    class uint8(unsignedinteger): pass
+    class _typedict(dict): pass
+    class complex192(complexfloating): pass
+    class timedelta64(signedinteger): pass
+    class int32(signedinteger): pass
+    class uint16(unsignedinteger): pass
+    class float32(floating): pass
+    class complex128(complexfloating, complex): pass
+    class float16(floating): pass
+    class int64(signedinteger): pass
+
+    buffer_type = memoryview
+    bool8 = bool_
+    byte = int8
+    bytes0 = bytes_
+    cdouble = complex128
+    cfloat = complex128
+    clongdouble = complex192
+    clongfloat = complex192
+    complex_ = complex128
+    csingle = complex64
+    double = float64
+    float_ = float64
+    half = float16
+    int0 = int32
+    int_ = int32
+    intc = int32
+    intp = int32
+    long = int32
+    longcomplex = complex192
+    longdouble = float96
+    longfloat = float96
+    longlong = int64
+    object0 = object_
+    object_ = object_
+    short = int16
+    single = float32
+    singlecomplex = complex64
+    str0 = str_
+    string_ = bytes_
+    ubyte = uint8
+    uint = uint32
+    uint0 = uint32
+    uintc = uint32
+    uintp = uint32
+    ulonglong = uint64
+    unicode = str_
+    unicode_ = str_
+    ushort = uint16
+    void0 = void
     ''')
 
 
diff -Nru astroid-1.6.5/astroid/brain/brain_pkg_resources.py astroid-2.0/astroid/brain/brain_pkg_resources.py
--- astroid-1.6.5/astroid/brain/brain_pkg_resources.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_pkg_resources.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,4 +1,5 @@
-# Copyright (c) 2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2016, 2018 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2016 Ceridwen <ceridwenv@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
@@ -65,6 +66,7 @@
 def get_distribution(dist):
     return Distribution(dist)
 
+_namespace_packages = {}
 ''')
 
 register_module_extender(MANAGER, 'pkg_resources', pkg_resources_transform)
diff -Nru astroid-1.6.5/astroid/brain/brain_pytest.py astroid-2.0/astroid/brain/brain_pytest.py
--- astroid-1.6.5/astroid/brain/brain_pytest.py	2018-05-13 12:38:38.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_pytest.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,5 +1,8 @@
 # Copyright (c) 2014-2016 Claudiu Popa <pcmanticore@gmail.com>
-# Copyright (c) 2016 Cara Vinson <ceridwenv@gmail.com>
+# Copyright (c) 2014 Jeff Quast <contact@jeffquast.com>
+# Copyright (c) 2014 Google, Inc.
+# Copyright (c) 2016 Florian Bruhin <me@the-compiler.org>
+# Copyright (c) 2016 Ceridwen <ceridwenv@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
diff -Nru astroid-1.6.5/astroid/brain/brain_qt.py astroid-2.0/astroid/brain/brain_qt.py
--- astroid-1.6.5/astroid/brain/brain_qt.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_qt.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,4 +1,7 @@
 # Copyright (c) 2015-2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2016 Ceridwen <ceridwenv@gmail.com>
+# Copyright (c) 2017 Roy Wright <roy@wright.org>
+# Copyright (c) 2018 Ashley Whetter <ashley@awhetter.co.uk>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
@@ -22,7 +25,7 @@
     return False
 
 
-def transform_pyqt_signal(node):    
+def transform_pyqt_signal(node):
     module = parse('''
     class pyqtSignal(object):
         def connect(self, slot, type=None, no_receiver_check=False):
@@ -38,6 +41,22 @@
     node.instance_attrs['connect'] = signal_cls['connect']
 
 
+def transform_pyside_signal(node):
+    module = parse('''
+    class NotPySideSignal(object):
+        def connect(self, receiver, type=None):
+            pass
+        def disconnect(self, receiver):
+            pass
+        def emit(self, *args):
+            pass
+    ''')
+    signal_cls = module['NotPySideSignal']
+    node.instance_attrs['connect'] = signal_cls['connect']
+    node.instance_attrs['disconnect'] = signal_cls['disconnect']
+    node.instance_attrs['emit'] = signal_cls['emit']
+
+
 def pyqt4_qtcore_transform():
     return AstroidBuilder(MANAGER).string_build('''
 
@@ -50,4 +69,6 @@
 
 register_module_extender(MANAGER, 'PyQt4.QtCore', pyqt4_qtcore_transform)
 MANAGER.register_transform(nodes.FunctionDef, transform_pyqt_signal,
-                           _looks_like_signal)
\ Pas de fin de ligne à la fin du fichier
+                           _looks_like_signal)
+MANAGER.register_transform(nodes.ClassDef, transform_pyside_signal,
+                           lambda node: node.qname() == 'PySide.QtCore.Signal')
diff -Nru astroid-1.6.5/astroid/brain/brain_random.py astroid-2.0/astroid/brain/brain_random.py
--- astroid-1.6.5/astroid/brain/brain_random.py	1970-01-01 01:00:00.000000000 +0100
+++ astroid-2.0/astroid/brain/brain_random.py	2018-07-15 09:19:27.000000000 +0200
@@ -0,0 +1,97 @@
+# Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
+# For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
+import random
+
+import astroid
+from astroid import helpers
+from astroid import MANAGER
+
+
+ACCEPTED_ITERABLES_FOR_SAMPLE = (
+    astroid.List,
+    astroid.Set,
+    astroid.Tuple,
+)
+
+
+def _clone_node_with_lineno(node, parent, lineno):
+    cls = node.__class__
+    other_fields = node._other_fields
+    _astroid_fields = node._astroid_fields
+    init_params = {
+        'lineno': lineno,
+        'col_offset': node.col_offset,
+        'parent': parent
+    }
+    postinit_params = {
+        param: getattr(node, param)
+        for param in _astroid_fields
+    }
+    if other_fields:
+        init_params.update({
+            param: getattr(node, param)
+            for param in other_fields
+        })
+    new_node = cls(**init_params)
+    if hasattr(node, 'postinit') and _astroid_fields:
+        new_node.postinit(**postinit_params)
+    return new_node
+
+
+def infer_random_sample(node, context=None):
+    if len(node.args) != 2:
+        raise astroid.UseInferenceDefault
+
+    length = node.args[1]
+    if not isinstance(length, astroid.Const):
+        raise astroid.UseInferenceDefault
+    if not isinstance(length.value, int):
+        raise astroid.UseInferenceDefault
+
+    inferred_sequence = helpers.safe_infer(node.args[0], context=context)
+    if inferred_sequence in (None, astroid.Uninferable):
+        raise astroid.UseInferenceDefault
+
+    if not isinstance(inferred_sequence, ACCEPTED_ITERABLES_FOR_SAMPLE):
+        raise astroid.UseInferenceDefault
+
+    if length.value > len(inferred_sequence.elts):
+        # In this case, this will raise a ValueError
+        raise astroid.UseInferenceDefault
+
+    try:
+        elts = random.sample(inferred_sequence.elts, length.value)
+    except ValueError:
+        raise astroid.UseInferenceDefault
+
+    new_node = astroid.List(
+        lineno=node.lineno,
+        col_offset=node.col_offset,
+        parent=node.scope(),
+    )
+    new_elts = [
+        _clone_node_with_lineno(
+            elt,
+            parent=new_node,
+            lineno=new_node.lineno
+        )
+        for elt in elts
+    ]
+    new_node.postinit(new_elts)
+    return iter((new_node, ))
+
+
+def _looks_like_random_sample(node):
+    func = node.func
+    if isinstance(func, astroid.Attribute):
+        return func.attrname == 'sample'
+    if isinstance(func, astroid.Name):
+        return func.name == 'sample'
+    return False
+
+
+MANAGER.register_transform(
+    astroid.Call,
+    astroid.inference_tip(infer_random_sample),
+    _looks_like_random_sample,
+)
